library movable_widget;

import 'package:flutter/gestures.dart';
import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';

/// A Calculator.
class MovableWidget extends StatefulWidget {
  final Widget widget;
  final double _top;
  final double _left;
  final double _right;
  final double _bottom;

  MovableWidget(this._top, this._left, this._right, this._bottom, this.widget);

  @override
  State<StatefulWidget> createState() {
    // TODO: implement createState
    return MovableState(_top, _left, _right, _bottom, widget);
  }
}

class MovableState extends State<MovableWidget>
    with SingleTickerProviderStateMixin {
  double _top;
  double _left;
  double _right;
  double _bottom;
  Widget child;

  MovableState(this._top, this._left, this._bottom, this._right, this.child);

  @override
  Widget build(BuildContext context) {
    return Stack(
      children: <Widget>[
        Positioned(
          top: _top,
          left: _left,
          bottom: _bottom,
          right: _right,
          child: GestureDetector(
            child: child,
            onPanDown: (DragDownDetails e) {
              print("用户手指按下：${e.globalPosition}");
            },
            onPanUpdate: (DragUpdateDetails e) {
              setState(() {
                double left = _left + e.delta.dx;
                double top = _top + e.delta.dy;
                if (top >= _bottom) {
                  _top = _bottom;
                }
                if (left >= _right) {
                  _left = _right;
                }
              });
            },
            onPanEnd: (DragEndDetails e) {
              print(e.velocity);
            },
          ),
        )
      ],
    );
  }
}
